/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2004-2011 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/********************************************************************************/
/*                                                                              */
/*                                  Pio (C++)                                   */
/*                                                                              */
/*                        Polyglot Input/Output Library                         */
/*                                                                              */
/*                      projet Estime, INRIA-Rocquencourt                       */
/*                                                                              */
/*  Copyright 2004-2011 INRIA.                                                  */
/*  Institut National de Recherche en Informatique et en Automatique.           */
/*  All rights reserved. This file is distributed only by permission.           */
/*                                                                              */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                                */
/*                                                                              */
/********************************************************************************/

/***********************************************************************/
/*                                                                     */
/*                              PIO (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2005-2007 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: lexem.cpp,v 1.3 2011-02-23 17:43:29 fclement Exp $ */

#include "lexem.hpp"

namespace io{

  //Lexem
  Single_type Lexem::type() const{return lexem_type;}
  //constructeurs:
  Lexem::Lexem(const int& x):i(x){lexem_type = INT;}
  Lexem::Lexem(const boolean& x):b(x){lexem_type = BOOLEAN;}
  Lexem::Lexem(const double& x):d(x){lexem_type = FLOAT;}
  Lexem::Lexem(const string& x):s(x){lexem_type = STRING;}
  Lexem::Lexem(const float_triple& x):ft(x){lexem_type = FLOAT_TRIPLE;}
  Lexem::Lexem(const float_couple& x):fc(x){lexem_type = FLOAT_COUPLE;}
  Lexem::Lexem(const int_triple& x):it(x){lexem_type = INT_TRIPLE;}
  Lexem::Lexem(const int_couple& x):ic(x){lexem_type = INT_COUPLE;}
  Lexem::Lexem(const boolean_triple& x):bt(x){lexem_type = BOOLEAN_TRIPLE;}
  Lexem::Lexem(const boolean_couple& x):bc(x){lexem_type = BOOLEAN_COUPLE;}
  //destructeur:
  Lexem::~Lexem(){}
  //convertisseurs:
  int & Lexem::to_int(){return i.data();}
  boolean & Lexem::to_boolean(){return b.data();}
  double & Lexem::to_float(){return d.data();}
  double & Lexem::to_double(){return d.data();}
  string & Lexem::to_string(){return s.data();}
  float_triple & Lexem::to_float_triple(){return ft.data();}
  float_couple &  Lexem::to_float_couple(){return fc.data();}
  int_triple & Lexem::to_int_triple(){return it.data();}
  int_couple & Lexem::to_int_couple(){return ic.data();}
  boolean_triple & Lexem::to_boolean_triple(){return bt.data();}
  boolean_couple & Lexem::to_boolean_couple(){return bc.data();}
  const int & Lexem::to_int()const {return i.data();}
  const boolean & Lexem::to_boolean()const {return b.data();}
  const double & Lexem::to_float()const {return d.data();}
  const double & Lexem::to_double()const {return d.data();}
  const string & Lexem::to_string()const {return s.data();}
  const float_triple & Lexem::to_float_triple()const {return ft.data();}
  const float_couple &  Lexem::to_float_couple()const {return fc.data();}
  const int_triple & Lexem::to_int_triple()const {return it.data();}
  const int_couple & Lexem::to_int_couple()const {return ic.data();}
  const boolean_triple & Lexem::to_boolean_triple()const {return bt.data();}
  const boolean_couple & Lexem::to_boolean_couple()const {return bc.data();}

}
