/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2004-2011 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/********************************************************************************/
/*                                                                              */
/*                                  Pio (C++)                                   */
/*                                                                              */
/*                        Polyglot Input/Output Library                         */
/*                                                                              */
/*                      projet Estime, INRIA-Rocquencourt                       */
/*                                                                              */
/*  Copyright 2004-2011 INRIA.                                                  */
/*  Institut National de Recherche en Informatique et en Automatique.           */
/*  All rights reserved. This file is distributed only by permission.           */
/*                                                                              */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                                */
/*                                                                              */
/********************************************************************************/

/***********************************************************************/
/*                                                                     */
/*                              Io (C++)                               */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2005-2006 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: matrix_type1.hpp,v 1.3 2011-02-23 17:43:29 fclement Exp $ */

#include "elem.hpp"
#include "single_types.hpp"

#ifndef MATRIX_TYPE1_H
#define MATRIX_TYPE1_H

namespace io{
  class Matrix_type1{
    Single_type matrix_type1;
    char _layout;
    int m;
    int n;
  public:
    Single_type type() const;
    char layout() const;
    int n_rows() const{return m;};
    int n_cols() const{return n;};
    Elem<int* > i;
    Elem<boolean* > b;
    Elem<double* > d;
    Elem<string* > s;
    Elem< float_triple* > ft;
    Elem< float_couple* > fc;
    Elem< int_triple* > it;
    Elem< int_couple* > ic;
    Matrix_type1(){matrix_type1=EMPTY;_layout = 'C';}
    Matrix_type1(int mm,int nn,int* & i,char _layout_='C');
    Matrix_type1(int mm,int nn,boolean* & b,char _layout_='C');
    Matrix_type1(int mm,int nn,double* & d,char _layout_='C');
    Matrix_type1(int mm,int nn,string* & s,char _layout_='C');
    Matrix_type1(int mm,int nn,float_triple* &ft,char _layout_='C');
    Matrix_type1(int mm,int nn,float_couple* &f,char _layout_='C');
    Matrix_type1(int mm,int nn,int_triple* &it,char _layout_='C');
    Matrix_type1(int mm,int nn,int_couple* &i,char _layout_='C');
    void free();
    virtual ~Matrix_type1();
  };
  
}

#endif 
